;-------------------------------------------------------------------------------
DEBUG               equ 0
DEBUG_PERFT         equ 0
DEBUG_VALRAMO       equ 1
DEBUG_MOSSE         equ 0
DEBUG_ALFAGEMMA     equ 0
DEBUG_ASSERT        equ 0
DEBUG_GENERATORE    equ 0
DEBUG_CASASRC       equ 0
TEST_SCACCO         equ 1
ITERATIVE_PRUDENTE  equ 0

DEBUG_001           equ 1

CONTA_MOSSE         equ 1
DEBUG_SIGLA         equ 0
USA_ZOBRIST         equ 0
HASH_ENTRIES		    equ 010000h
;-------------------------------------------------------------------------------
LF               equ 10
CR               equ 13
;-------------------------------------------------------------------------------
extern _SysElapsed: proc
extern _SysPrintf: proc
extern _SysChar: proc
extern _SysGetChar: proc
extern _printf: proc
extern _getchar: proc
;-------------------------------------------------------------------------------
global TestRoutine: proc
global COUNTER001: dword
global BreakPoint: proc
global TestMossaOk: proc
global TestMosseOk: proc
global TestSiglaPezzo: proc
;-------------------------------------------------------------------------------
;                                                                    MACRO DEBUG
;-------------------------------------------------------------------------------
PRINT macro stringa, par1, par2, par3
	pushad
  ifnb <par3>
  	push par3
  endif
  ifnb <par2>
  	push par2
  endif
  ifnb <par1>
  	push par1
  endif
  push offset stringa
  call _printf
  pop ecx
  ifnb <par3>
	  pop ecx
  endif
  ifnb <par2>
	  pop ecx
  endif
  ifnb <par1>
	  pop ecx
  endif
  popad
endm
;-------------------------------------------------------------------------------
PUTCHARS macro c1, c2, c3, c4
    ifnb <c1>
    	PUTCHAR c1
    endif
    ifnb <c2>
    	PUTCHAR c2
    endif
    ifnb <c3>
    	PUTCHAR c3
    endif
    ifnb <c4>
    	PUTCHAR c4
    endif
endm
;-------------------------------------------------------------------------------
PUTCHAR macro c
    pushad
    and eax,0ffh
    mov al,c
    push eax
    call _SysChar
    pop eax
    popad
endm
;-------------------------------------------------------------------------------
ACAPO macro
    push eax
    if 0
    	mov al, CR
	    PUTCHAR al
    endif
    mov al, LF
    PUTCHAR al
    pop eax
endm
;-------------------------------------------------------------------------------
TESTPOINTER macro puntatore, inizio, fine, j_err
	local @tp_ok, @tp_err
	if DEBUG_ASSERT
      cmp puntatore, offset inizio
      jl @tp_err
      cmp puntatore, offset fine
      jl @tp_ok
    @tp_err:
      call BreakPoint
      ifnb <j_err>
      	jmp j_err
      endif
    @tp_ok:
  endif
endm

TESTEQ macro valore1, valore2, j_err
	local @tp_ok, @tp_err
	if DEBUG_ASSERT
	  cmp valore1, valore2
  	je @tp_ok
  @tp_err:
      call BreakPoint
      ifnb <j_err>
      	jmp j_err
      endif
  @tp_ok:
  endif
endm

TESTNOEQ macro puntatore, valore, j_err
	local @tp_ok, @tp_err
	if DEBUG_ASSERT
	  cmp puntatore, valore
  	jne @tp_ok
  @tp_err:
      call BreakPoint
      ifnb <j_err>
      	jmp j_err
      endif
  @tp_ok:
  endif
endm
;-------------------------------------------------------------------------------
TESTMOSSE macro
  if DEBUG_ASSERT
	  call TestMosseOk
  endif
endm
;-------------------------------------------------------------------------------

