;-------------------------------------------------------------------------------
.686
.mmx
.model flat,STDCALL
;-------------------------------------------------------------------------------
.data
include motore.inc
include posizioni.inc
include debug.inc
include dati.inc
include valuta.inc
;-------------------------------------------------------------------------------
.code
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
_perfect proc
	pushad

  mov eax, _ret_vals.rLivello
 	mov _ret_vals.rLivAttuale, eax

	call SetPos

  xor ebp, ebp													; azzera il valore della posizione

pf_ciclonodi:
	add _ret_vals.rNumNodiL, 1
	adc _ret_vals.rNumNodiH, 0
;-------------------------------------------------------------------------------

	call GeneraMosse
	mov edx, [esi.nMosse]
	mov [esi.nEseguita], edx
  jmp pf_testultima
pf_cerca:
  mov edx, [esi.nEseguita]
  lea edx, [edx+size Mossa]
pf_testultima:   
  cmp edx, [esi.nMosse+size Nodo]
	je pf_finite            							; non ci sono altre mosse
pf_esegui:
  if 1
    cmp [esi.nLivello], 0
    jne pf_notick
    PUTCHAR '.'
  endif
pf_notick:
	call EseguiMossa
 	call TestScacco
  jp pf_nomatto													; mossa illegale perch lascia il RE sotto scacco
pf_matto:
  if DEBUG_ALFAGEMMA
  	PUTCHAR '!'
	endif
	if CONTA_MOSSE
    sub [esi.nNumMosseL], 1
    sbb [esi.nNumMosseH], 0
  endif
pf_annulla:
	mov edx, [esi.nEseguita]   						; carica la mossa eseguita
	call AnnullaMossa
	jmp pf_cerca
pf_nomatto:															; mossa legale
	add [esi.nNumValideL], 1
	adc [esi.nNumValideH], 0
  if CONTA_MOSSE
    add _ret_vals.rNumMosseL, 1
    adc _ret_vals.rNumMosseH, 0
  endif
pf_next:
	add esi,size Nodo       							; prossimo nodo
	mov eax,[esi.nLivello]
	cmp eax, _ret_vals.rLivAttuale
	jl pf_ciclonodi
pf_finite:
	if DEBUG_PERFT
		PUTCHAR '-'
  endif
	sub esi, size Nodo       							; nodo precedente
	cmp esi, offset nodi
	jge pf_annulla
pf_fine:
	emms
	popad
	ret
endp
;-------------------------------------------------------------------------------
;-------------------------------------------------------------------------------
end